Index: uspace/srv/net/tcp/conn.c
===================================================================
--- uspace/srv/net/tcp/conn.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/conn.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,8 +36,10 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
 #include <errno.h>
+#include <inet/endpoint.h>
 #include <io/log.h>
 #include <macros.h>
+#include <nettl/amap.h>
+#include <stdbool.h>
 #include <stdlib.h>
 #include "conn.h"
@@ -55,6 +57,8 @@
 #define TIME_WAIT_TIMEOUT	(2*MAX_SEGMENT_LIFETIME)
 
-LIST_INITIALIZE(conn_list);
-FIBRIL_MUTEX_INITIALIZE(conn_list_lock);
+static LIST_INITIALIZE(conn_list);
+/** Taken after tcp_conn_t lock */
+static FIBRIL_MUTEX_INITIALIZE(conn_list_lock);
+static amap_t *amap;
 
 static void tcp_conn_seg_process(tcp_conn_t *conn, tcp_segment_t *seg);
@@ -62,11 +66,24 @@
 static void tcp_conn_tw_timer_clear(tcp_conn_t *conn);
 
+/** Initialize connections. */
+int tcp_conns_init(void)
+{
+	int rc;
+
+	rc = amap_create(&amap);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		return ENOMEM;
+	}
+
+	return EOK;
+}
+
 /** Create new connection structure.
  *
- * @param lsock		Local socket (will be deeply copied)
- * @param fsock		Foreign socket (will be deeply copied)
+ * @param epp		Endpoint pair (will be deeply copied)
  * @return		New connection or NULL
  */
-tcp_conn_t *tcp_conn_new(tcp_sock_t *lsock, tcp_sock_t *fsock)
+tcp_conn_t *tcp_conn_new(inet_ep2_t *epp)
 {
 	tcp_conn_t *conn = NULL;
@@ -121,5 +138,5 @@
 	fibril_condvar_initialize(&conn->cstate_cv);
 
-	conn->cstate_cb = NULL;
+	conn->cb = NULL;
 
 	conn->cstate = st_listen;
@@ -128,7 +145,6 @@
 	conn->ap = ap_passive;
 	conn->fin_is_acked = false;
-	conn->ident.local = *lsock;
-	if (fsock != NULL)
-		conn->ident.foreign = *fsock;
+	if (epp != NULL)
+		conn->ident = *epp;
 
 	return conn;
@@ -184,5 +200,6 @@
 void tcp_conn_addref(tcp_conn_t *conn)
 {
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "%s: tcp_conn_addref(%p)", conn->name, conn);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "%s: tcp_conn_addref(%p) before=%zu",
+	    conn->name, conn, atomic_get(&conn->refcnt));
 	atomic_inc(&conn->refcnt);
 }
@@ -196,5 +213,6 @@
 void tcp_conn_delref(tcp_conn_t *conn)
 {
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "%s: tcp_conn_delref(%p)", conn->name, conn);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "%s: tcp_conn_delref(%p) before=%zu",
+	    conn->name, conn, atomic_get(&conn->refcnt));
 
 	if (atomic_predec(&conn->refcnt) == 0)
@@ -237,4 +255,7 @@
 
 	assert(conn->deleted == false);
+	conn->deleted = true;
+	conn->cb = NULL;
+	conn->cb_arg = NULL;
 	tcp_conn_delref(conn);
 }
@@ -244,10 +265,26 @@
  * Add connection to the connection map.
  */
-void tcp_conn_add(tcp_conn_t *conn)
-{
+int tcp_conn_add(tcp_conn_t *conn)
+{
+	inet_ep2_t aepp;
+	int rc;
+
 	tcp_conn_addref(conn);
 	fibril_mutex_lock(&conn_list_lock);
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_add: conn=%p", conn);
+
+	rc = amap_insert(amap, &conn->ident, conn, af_allow_system, &aepp);
+	if (rc != EOK) {
+		tcp_conn_delref(conn);
+		fibril_mutex_unlock(&conn_list_lock);
+		return rc;
+	}
+
+	conn->ident = aepp;
 	list_append(&conn->link, &conn_list);
 	fibril_mutex_unlock(&conn_list_lock);
+
+	return EOK;
 }
 
@@ -259,4 +296,5 @@
 {
 	fibril_mutex_lock(&conn_list_lock);
+	amap_remove(amap, &conn->ident);
 	list_remove(&conn->link);
 	fibril_mutex_unlock(&conn_list_lock);
@@ -275,7 +313,7 @@
 
 	/* Run user callback function */
-	if (conn->cstate_cb != NULL) {
+	if (conn->cb != NULL && conn->cb->cstate_change != NULL) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_state_set() - run user CB");
-		conn->cstate_cb(conn, conn->cstate_cb_arg);
+		conn->cb->cstate_change(conn, conn->cb_arg, old_state);
 	} else {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_state_set() - no user CB");
@@ -284,4 +322,5 @@
 	assert(old_state != st_closed);
 	if (nstate == st_closed) {
+		tcp_conn_remove(conn);
 		/* Drop one reference for now being in closed state */
 		tcp_conn_delref(conn);
@@ -332,70 +371,37 @@
 }
 
-/** Match socket with pattern. */
-static bool tcp_socket_match(tcp_sock_t *sock, tcp_sock_t *patt)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG2,
-	    "tcp_socket_match(sock=(%u), pat=(%u))", sock->port, patt->port);
-	
-	if ((!inet_addr_is_any(&patt->addr)) &&
-	    (!inet_addr_compare(&patt->addr, &sock->addr)))
-		return false;
-
-	if ((patt->port != TCP_PORT_ANY) &&
-	    (patt->port != sock->port))
-		return false;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, " -> match");
-
-	return true;
-}
-
-/** Match socket pair with pattern. */
-static bool tcp_sockpair_match(tcp_sockpair_t *sp, tcp_sockpair_t *pattern)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "tcp_sockpair_match(%p, %p)", sp, pattern);
-
-	if (!tcp_socket_match(&sp->local, &pattern->local))
-		return false;
-
-	if (!tcp_socket_match(&sp->foreign, &pattern->foreign))
-		return false;
-
-	return true;
-}
-
-/** Find connection structure for specified socket pair.
- *
- * A connection is uniquely identified by a socket pair. Look up our
- * connection map and return connection structure based on socket pair.
+/** Find connection structure for specified endpoint pair.
+ *
+ * A connection is uniquely identified by a endpoint pair. Look up our
+ * connection map and return connection structure based on endpoint pair.
  * The connection reference count is bumped by one.
  *
- * @param sp	Socket pair
+ * @param epp	Endpoint pair
  * @return	Connection structure or NULL if not found.
  */
-tcp_conn_t *tcp_conn_find_ref(tcp_sockpair_t *sp)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref(%p)", sp);
-	
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "compare conn (f:(%u), l:(%u))",
-	    sp->foreign.port, sp->local.port);
-	
+tcp_conn_t *tcp_conn_find_ref(inet_ep2_t *epp)
+{
+	int rc;
+	void *arg;
+	tcp_conn_t *conn;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref(%p)", epp);
+
 	fibril_mutex_lock(&conn_list_lock);
-	
-	list_foreach(conn_list, link, tcp_conn_t, conn) {
-		tcp_sockpair_t *csp = &conn->ident;
-		
-		log_msg(LOG_DEFAULT, LVL_DEBUG2, " - with (f:(%u), l:(%u))",
-		    csp->foreign.port, csp->local.port);
-		
-		if (tcp_sockpair_match(sp, csp)) {
-			tcp_conn_addref(conn);
-			fibril_mutex_unlock(&conn_list_lock);
-			return conn;
-		}
-	}
-	
+
+	rc = amap_find_match(amap, epp, &arg);
+	if (rc != EOK) {
+		assert(rc == ENOENT);
+		fibril_mutex_unlock(&conn_list_lock);
+		return NULL;
+	}
+
+	conn = (tcp_conn_t *)arg;
+	tcp_conn_addref(conn);
+
 	fibril_mutex_unlock(&conn_list_lock);
-	return NULL;
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref: got conn=%p",
+	    conn);
+	return conn;
 }
 
@@ -407,6 +413,6 @@
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_conn_reset()", conn->name);
+	conn->reset = true;
 	tcp_conn_state_set(conn, st_closed);
-	conn->reset = true;
 
 	tcp_conn_tw_timer_clear(conn);
@@ -877,5 +883,4 @@
 	if (conn->fin_is_acked) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: FIN acked -> Closed", conn->name);
-		tcp_conn_remove(conn);
 		tcp_conn_state_set(conn, st_closed);
 		return cp_done;
@@ -1006,5 +1011,9 @@
 
 	/* Signal to the receive function that new data has arrived */
-	fibril_condvar_broadcast(&conn->rcv_buf_cv);
+	if (xfer_size > 0) {
+		fibril_condvar_broadcast(&conn->rcv_buf_cv);
+		if (conn->cb != NULL && conn->cb->recv_data != NULL)
+			conn->cb->recv_data(conn, conn->cb_arg);
+	}
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "Received %zu bytes of data.", xfer_size);
@@ -1098,4 +1107,6 @@
 		conn->rcv_buf_fin = true;
 		fibril_condvar_broadcast(&conn->rcv_buf_cv);
+		if (conn->cb != NULL && conn->cb->recv_data != NULL)
+			conn->cb->recv_data(conn, conn->cb_arg);
 
 		tcp_segment_delete(seg);
@@ -1168,16 +1179,69 @@
  *
  * @param conn		Connection
- * @param seg		Segment
- */
-void tcp_conn_segment_arrived(tcp_conn_t *conn, tcp_segment_t *seg)
-{
+ * @param epp		Endpoint pair on which segment was received
+ * @param seg		Segment
+ */
+void tcp_conn_segment_arrived(tcp_conn_t *conn, inet_ep2_t *epp,
+    tcp_segment_t *seg)
+{
+	inet_ep2_t aepp;
+	inet_ep2_t oldepp;
+	int rc;
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_conn_segment_arrived(%p)",
 	    conn->name, seg);
 
+	tcp_conn_lock(conn);
+
+	if (conn->cstate == st_closed) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "Connection is closed.");
+		tcp_unexpected_segment(epp, seg);
+		tcp_conn_unlock(conn);
+		return;
+	}
+
+	if (inet_addr_is_any(&conn->ident.remote.addr) ||
+	    conn->ident.remote.port == inet_port_any ||
+	    inet_addr_is_any(&conn->ident.local.addr)) {
+
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "tcp_conn_segment_arrived: "
+		    "Changing connection ID, updating amap.");
+		oldepp = conn->ident;
+
+		/* Need to remove and re-insert connection with new identity */
+		fibril_mutex_lock(&conn_list_lock);
+
+		if (inet_addr_is_any(&conn->ident.remote.addr))
+			conn->ident.remote.addr = epp->remote.addr;
+
+		if (conn->ident.remote.port == inet_port_any)
+			conn->ident.remote.port = epp->remote.port;
+
+		if (inet_addr_is_any(&conn->ident.local.addr))
+			conn->ident.local.addr = epp->local.addr;
+
+		rc = amap_insert(amap, &conn->ident, conn, af_allow_system, &aepp);
+		if (rc != EOK) {
+			assert(rc != EEXISTS);
+			assert(rc == ENOMEM);
+			log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
+			fibril_mutex_unlock(&conn_list_lock);
+			tcp_conn_unlock(conn);
+			return;
+		}
+
+		amap_remove(amap, &oldepp);
+		fibril_mutex_unlock(&conn_list_lock);
+
+		conn->name = (char *) "a";
+	}
+
 	switch (conn->cstate) {
 	case st_listen:
-		tcp_conn_sa_listen(conn, seg); break;
+		tcp_conn_sa_listen(conn, seg);
+		break;
 	case st_syn_sent:
-		tcp_conn_sa_syn_sent(conn, seg); break;
+		tcp_conn_sa_syn_sent(conn, seg);
+		break;
 	case st_syn_received:
 	case st_established:
@@ -1189,9 +1253,12 @@
 	case st_time_wait:
 		/* Process segments in order of sequence number */
-		tcp_conn_sa_queue(conn, seg); break;
+		tcp_conn_sa_queue(conn, seg);
+		break;
 	case st_closed:
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "state=%d", (int) conn->cstate);
 		assert(false);
 	}
+
+	tcp_conn_unlock(conn);
 }
 
@@ -1216,5 +1283,4 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: TW Timeout -> Closed", conn->name);
-	tcp_conn_remove(conn);
 	tcp_conn_state_set(conn, st_closed);
 
@@ -1263,45 +1329,46 @@
 }
 
-/** Handle unexpected segment received on a socket pair.
+/** Handle unexpected segment received on an endpoint pair.
  *
  * We reply with an RST unless the received segment has RST.
  *
- * @param sp		Socket pair which received the segment
+ * @param sp		Endpoint pair which received the segment
  * @param seg		Unexpected segment
  */
-void tcp_unexpected_segment(tcp_sockpair_t *sp, tcp_segment_t *seg)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_unexpected_segment(%p, %p)", sp, seg);
+void tcp_unexpected_segment(inet_ep2_t *epp, tcp_segment_t *seg)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_unexpected_segment(%p, %p)", epp,
+	    seg);
 
 	if ((seg->ctrl & CTL_RST) == 0)
-		tcp_reply_rst(sp, seg);
-}
-
-/** Compute flipped socket pair for response.
- *
- * Flipped socket pair has local and foreign sockets exchanged.
- *
- * @param sp		Socket pair
- * @param fsp		Place to store flipped socket pair
- */
-void tcp_sockpair_flipped(tcp_sockpair_t *sp, tcp_sockpair_t *fsp)
-{
-	fsp->local = sp->foreign;
-	fsp->foreign = sp->local;
+		tcp_reply_rst(epp, seg);
+}
+
+/** Compute flipped endpoint pair for response.
+ *
+ * Flipped endpoint pair has local and remote endpoints exchanged.
+ *
+ * @param epp		Endpoint pair
+ * @param fepp		Place to store flipped endpoint pair
+ */
+void tcp_ep2_flipped(inet_ep2_t *epp, inet_ep2_t *fepp)
+{
+	fepp->local = epp->remote;
+	fepp->remote = epp->local;
 }
 
 /** Send RST in response to an incoming segment.
  *
- * @param sp		Socket pair which received the segment
+ * @param epp		Endpoint pair which received the segment
  * @param seg		Incoming segment
  */
-void tcp_reply_rst(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_reply_rst(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_segment_t *rseg;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_reply_rst(%p, %p)", sp, seg);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_reply_rst(%p, %p)", epp, seg);
 
 	rseg = tcp_segment_make_rst(seg);
-	tcp_transmit_segment(sp, rseg);
+	tcp_transmit_segment(epp, rseg);
 }
 
Index: uspace/srv/net/tcp/conn.h
===================================================================
--- uspace/srv/net/tcp/conn.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/conn.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,10 +36,12 @@
 #define CONN_H
 
+#include <inet/endpoint.h>
 #include <stdbool.h>
 #include "tcp_type.h"
 
-extern tcp_conn_t *tcp_conn_new(tcp_sock_t *, tcp_sock_t *);
+extern int tcp_conns_init(void);
+extern tcp_conn_t *tcp_conn_new(inet_ep2_t *);
 extern void tcp_conn_delete(tcp_conn_t *);
-extern void tcp_conn_add(tcp_conn_t *);
+extern int tcp_conn_add(tcp_conn_t *);
 extern void tcp_conn_remove(tcp_conn_t *);
 extern void tcp_conn_reset(tcp_conn_t *conn);
@@ -47,5 +49,5 @@
 extern void tcp_conn_fin_sent(tcp_conn_t *);
 extern void tcp_conn_ack_of_fin_rcvd(tcp_conn_t *);
-extern tcp_conn_t *tcp_conn_find_ref(tcp_sockpair_t *);
+extern tcp_conn_t *tcp_conn_find_ref(inet_ep2_t *);
 extern void tcp_conn_addref(tcp_conn_t *);
 extern void tcp_conn_delref(tcp_conn_t *);
@@ -53,9 +55,10 @@
 extern void tcp_conn_unlock(tcp_conn_t *);
 extern bool tcp_conn_got_syn(tcp_conn_t *);
-extern void tcp_conn_segment_arrived(tcp_conn_t *, tcp_segment_t *);
+extern void tcp_conn_segment_arrived(tcp_conn_t *, inet_ep2_t *,
+    tcp_segment_t *);
 extern void tcp_conn_trim_seg_to_wnd(tcp_conn_t *, tcp_segment_t *);
-extern void tcp_unexpected_segment(tcp_sockpair_t *, tcp_segment_t *);
-extern void tcp_sockpair_flipped(tcp_sockpair_t *, tcp_sockpair_t *);
-extern void tcp_reply_rst(tcp_sockpair_t *, tcp_segment_t *);
+extern void tcp_unexpected_segment(inet_ep2_t *, tcp_segment_t *);
+extern void tcp_ep2_flipped(inet_ep2_t *, inet_ep2_t *);
+extern void tcp_reply_rst(inet_ep2_t *, tcp_segment_t *);
 
 #endif
Index: uspace/srv/net/tcp/ncsim.c
===================================================================
--- uspace/srv/net/tcp/ncsim.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/ncsim.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,4 +42,5 @@
 #include <async.h>
 #include <errno.h>
+#include <inet/endpoint.h>
 #include <io/log.h>
 #include <stdlib.h>
@@ -65,8 +66,8 @@
 /** Bounce segment through simulator into receive queue.
  *
- * @param sp	Socket pair, oriented for transmission
+ * @param epp	Endpoint pair, oriented for transmission
  * @param seg	Segment
  */
-void tcp_ncsim_bounce_seg(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_ncsim_bounce_seg(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_squeue_entry_t *sqe;
@@ -75,5 +76,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_ncsim_bounce_seg()");
-	tcp_rqueue_bounce_seg(sp, seg);
+	tcp_rqueue_bounce_seg(epp, seg);
 	return;
 
@@ -92,5 +93,5 @@
 
 	sqe->delay = random() % (1000 * 1000);
-	sqe->sp = *sp;
+	sqe->epp = *epp;
 	sqe->seg = seg;
 
@@ -147,5 +148,5 @@
 
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "NCSim - End Sleep");
-		tcp_rqueue_bounce_seg(&sqe->sp, sqe->seg);
+		tcp_rqueue_bounce_seg(&sqe->epp, sqe->seg);
 		free(sqe);
 	}
Index: uspace/srv/net/tcp/ncsim.h
===================================================================
--- uspace/srv/net/tcp/ncsim.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/ncsim.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,8 +36,9 @@
 #define NCSIM_H
 
+#include <inet/endpoint.h>
 #include "tcp_type.h"
 
 extern void tcp_ncsim_init(void);
-extern void tcp_ncsim_bounce_seg(tcp_sockpair_t *, tcp_segment_t *);
+extern void tcp_ncsim_bounce_seg(inet_ep2_t *, tcp_segment_t *);
 extern void tcp_ncsim_fibril_start(void);
 
Index: uspace/srv/net/tcp/pdu.c
===================================================================
--- uspace/srv/net/tcp/pdu.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/pdu.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,4 +38,5 @@
 #include <byteorder.h>
 #include <errno.h>
+#include <inet/endpoint.h>
 #include <mem.h>
 #include <stdlib.h>
@@ -125,11 +126,11 @@
 }
 
-static void tcp_header_setup(tcp_sockpair_t *sp, tcp_segment_t *seg, tcp_header_t *hdr)
+static void tcp_header_setup(inet_ep2_t *epp, tcp_segment_t *seg, tcp_header_t *hdr)
 {
 	uint16_t doff_flags;
 	uint16_t doff;
 
-	hdr->src_port = host2uint16_t_be(sp->local.port);
-	hdr->dest_port = host2uint16_t_be(sp->foreign.port);
+	hdr->src_port = host2uint16_t_be(epp->local.port);
+	hdr->dest_port = host2uint16_t_be(epp->remote.port);
 	hdr->seq = host2uint32_t_be(seg->seq);
 	hdr->ack = host2uint32_t_be(seg->ack);
@@ -190,5 +191,5 @@
 }
 
-static int tcp_header_encode(tcp_sockpair_t *sp, tcp_segment_t *seg,
+static int tcp_header_encode(inet_ep2_t *epp, tcp_segment_t *seg,
     void **header, size_t *size)
 {
@@ -199,5 +200,5 @@
 		return ENOMEM;
 
-	tcp_header_setup(sp, seg, hdr);
+	tcp_header_setup(epp, seg, hdr);
 	*header = hdr;
 	*size = sizeof(tcp_header_t);
@@ -293,5 +294,5 @@
 
 /** Decode incoming PDU */
-int tcp_pdu_decode(tcp_pdu_t *pdu, tcp_sockpair_t *sp, tcp_segment_t **seg)
+int tcp_pdu_decode(tcp_pdu_t *pdu, inet_ep2_t *epp, tcp_segment_t **seg)
 {
 	tcp_segment_t *nseg;
@@ -307,8 +308,8 @@
 	hdr = (tcp_header_t *)pdu->header;
 
-	sp->local.port = uint16_t_be2host(hdr->dest_port);
-	sp->local.addr = pdu->dest;
-	sp->foreign.port = uint16_t_be2host(hdr->src_port);
-	sp->foreign.addr = pdu->src;
+	epp->local.port = uint16_t_be2host(hdr->dest_port);
+	epp->local.addr = pdu->dest;
+	epp->remote.port = uint16_t_be2host(hdr->src_port);
+	epp->remote.addr = pdu->src;
 
 	*seg = nseg;
@@ -317,5 +318,5 @@
 
 /** Encode outgoing PDU */
-int tcp_pdu_encode(tcp_sockpair_t *sp, tcp_segment_t *seg, tcp_pdu_t **pdu)
+int tcp_pdu_encode(inet_ep2_t *epp, tcp_segment_t *seg, tcp_pdu_t **pdu)
 {
 	tcp_pdu_t *npdu;
@@ -327,7 +328,7 @@
 		return ENOMEM;
 
-	npdu->src = sp->local.addr;
-	npdu->dest = sp->foreign.addr;
-	tcp_header_encode(sp, seg, &npdu->header, &npdu->header_size);
+	npdu->src = epp->local.addr;
+	npdu->dest = epp->remote.addr;
+	tcp_header_encode(epp, seg, &npdu->header, &npdu->header_size);
 
 	text_size = tcp_segment_text_size(seg);
Index: uspace/srv/net/tcp/pdu.h
===================================================================
--- uspace/srv/net/tcp/pdu.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/pdu.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,4 +36,5 @@
 #define PDU_H
 
+#include <inet/endpoint.h>
 #include <sys/types.h>
 #include "std.h"
@@ -42,6 +43,6 @@
 extern tcp_pdu_t *tcp_pdu_create(void *, size_t, void *, size_t);
 extern void tcp_pdu_delete(tcp_pdu_t *);
-extern int tcp_pdu_decode(tcp_pdu_t *, tcp_sockpair_t *, tcp_segment_t **);
-extern int tcp_pdu_encode(tcp_sockpair_t *, tcp_segment_t *, tcp_pdu_t **);
+extern int tcp_pdu_decode(tcp_pdu_t *, inet_ep2_t *, tcp_segment_t **);
+extern int tcp_pdu_encode(inet_ep2_t *, tcp_segment_t *, tcp_pdu_t **);
 
 #endif
Index: uspace/srv/net/tcp/rqueue.c
===================================================================
--- uspace/srv/net/tcp/rqueue.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/rqueue.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -67,10 +67,10 @@
  * This is for testing purposes only.
  *
- * @param sp	Socket pair, oriented for transmission
+ * @param sp	Endpoint pair, oriented for transmission
  * @param seg	Segment
  */
-void tcp_rqueue_bounce_seg(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_rqueue_bounce_seg(inet_ep2_t *epp, tcp_segment_t *seg)
 {
-	tcp_sockpair_t rident;
+	inet_ep2_t rident;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_rqueue_bounce_seg()");
@@ -80,5 +80,5 @@
 	tcp_segment_t *dseg;
 
-	if (tcp_pdu_encode(sp, seg, &pdu) != EOK) {
+	if (tcp_pdu_encode(epp, seg, &pdu) != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
 		return;
@@ -97,5 +97,5 @@
 #else
 	/* Reverse the identification */
-	tcp_sockpair_flipped(sp, &rident);
+	tcp_ep2_flipped(epp, &rident);
 
 	/* Insert segment back into rqueue */
@@ -106,8 +106,8 @@
 /** Insert segment into receive queue.
  *
- * @param sp	Socket pair, oriented for reception
+ * @param epp	Endpoint pair, oriented for reception
  * @param seg	Segment
  */
-void tcp_rqueue_insert_seg(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_rqueue_insert_seg(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_rqueue_entry_t *rqe;
@@ -122,5 +122,5 @@
 	}
 
-	rqe->sp = *sp;
+	rqe->epp = *epp;
 	rqe->seg = seg;
 
@@ -140,5 +140,5 @@
 		rqe = list_get_instance(link, tcp_rqueue_entry_t, link);
 
-		tcp_as_segment_arrived(&rqe->sp, rqe->seg);
+		tcp_as_segment_arrived(&rqe->epp, rqe->seg);
 		free(rqe);
 	}
Index: uspace/srv/net/tcp/rqueue.h
===================================================================
--- uspace/srv/net/tcp/rqueue.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/rqueue.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,9 +36,10 @@
 #define RQUEUE_H
 
+#include <inet/endpoint.h>
 #include "tcp_type.h"
 
 extern void tcp_rqueue_init(void);
-extern void tcp_rqueue_bounce_seg(tcp_sockpair_t *, tcp_segment_t *);
-extern void tcp_rqueue_insert_seg(tcp_sockpair_t *, tcp_segment_t *);
+extern void tcp_rqueue_bounce_seg(inet_ep2_t *, tcp_segment_t *);
+extern void tcp_rqueue_insert_seg(inet_ep2_t *, tcp_segment_t *);
 extern void tcp_rqueue_handler(void *);
 extern void tcp_rqueue_fibril_start(void);
